diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/devicemanagement/DeviceManagementService.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/devicemanagement/DeviceManagementService.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/devicemanagement/DeviceManagementService.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/devicemanagement/DeviceManagementService.java	2017-07-06 20:45:58.267482000 +0900
@@ -0,0 +1,365 @@
+
+package com.android.server.devicemanagement;
+
+import java.net.InetAddress;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+
+import android.content.ComponentName;
+import android.content.Context;
+import android.content.Intent;
+import android.net.DhcpInfo;
+import android.net.wifi.WifiInfo;
+import android.net.wifi.WifiManager;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.service.devicemanagement.Device;
+import android.service.devicemanagement.DeviceList;
+import android.service.devicemanagement.IDeviceManagementService;
+import android.service.remote.IRemoteService;
+import android.util.Log;
+import android.util.SparseArray;
+
+public class DeviceManagementService extends IDeviceManagementService.Stub {
+    private Context mContext;
+
+    public static final String TAG = "DeviceManagementService";
+    public RecommenderUDPSender sender;
+
+    private List<Device> configuredDeviceList;
+    private HashMap<String, Device> nameToDevice;
+    private ArrayList<Device> connectedDevices;
+    //private ArrayList<Device> cachedActivityResourceDevices;
+
+
+    private SparseArray<ArrayList<String>> resourceToAllowedDevices;
+
+    public final int SYSTEM_SERVICE_LIST = 1;
+    public final int TASK_EXECUTOR_LIST = 2;
+
+    public DeviceManagementService(Context context) {
+        // TODO Auto-generated constructor stub
+        mContext = context;
+        RecommenderUDPReceiver t = new RecommenderUDPReceiver(getBroadcastIp(), context);
+        RecommenderTCPReceiver tr = new RecommenderTCPReceiver();
+        t.start();
+        tr.start();
+
+        resourceToAllowedDevices = new SparseArray<ArrayList<String>>();
+        for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+        {
+            if(resourceToAllowedDevices.get(i) == null)
+                resourceToAllowedDevices.put(i, new ArrayList<String>());
+        }
+
+        nameToDevice = new HashMap<String, Device>();
+        connectedDevices = new ArrayList<Device>();
+        //cachedActivityResourceDevices = new ArrayList<Device>();
+    }
+    public void initDevices()
+    {
+        nameToDevice.clear();
+        if(configuredDeviceList != null)
+            configuredDeviceList.clear();
+
+        for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+        {
+            if(resourceToAllowedDevices.get(i) != null)
+                resourceToAllowedDevices.get(i).clear();
+        }
+    }
+
+    public int getNumofConfiguredDevices()
+    {
+        if(configuredDeviceList == null)
+            return 0;
+        else
+            return configuredDeviceList.size();
+    }
+
+    public Device getDevice(String name)
+    {
+        return nameToDevice.get(name);
+    }
+
+    public void constructCluster(List<Device> devicelist) {
+        this.configuredDeviceList = devicelist;
+        IRemoteService remoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+        try
+        {
+            remoteService.sendResourceRequests(devicelist);
+        }
+        catch (RemoteException e)
+        {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+
+        for (Device d : configuredDeviceList) {
+            if(!nameToDevice.containsKey(d.deviceName))
+                nameToDevice.put(d.deviceName, d);
+        }
+
+        //categorizeDevices();
+    }
+
+    public void showRequestDialog(String deviceName, String deviceIP, int askedResources[])
+    {
+        Log.d("SBJSBJ showRequestDialog", "SBJSBJ showRequestDialog deviceName : " + deviceName);
+        Log.d("SBJSBJ showRequestDialog", "SBJSBJ showRequestDialog deviceIP : " + deviceIP);
+
+        Device device;
+
+        if(nameToDevice.containsKey(deviceName))
+            device = nameToDevice.get(deviceName);
+        else
+        {
+            device = new Device(deviceIP, "-1", deviceName, 0, 0);
+            nameToDevice.put(deviceName, device);
+        }
+
+    	/*ComponentName compName = new ComponentName(
+                "com.android.test"
+                , "com.android.test.RequestDialog");*/
+        /*ComponentName compName = new ComponentName(
+                "com.example.aa"
+                , "com.example.aa.RequestDialog");*/
+        ComponentName compName = new ComponentName(
+                "com.android.settings"
+                , "com.android.settings.RequestDialog");
+
+        Intent intent = new Intent("android.intent.action.COLLABOROID");
+        //intent.addCategory("android.intent.category.VIDEO_STREAMING");
+        intent.setComponent(compName);
+        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+        intent.addCategory(Intent.CATEGORY_DEFAULT);
+
+        intent.putExtra("deviceName", device.deviceName);
+        intent.putExtra("resources", askedResources);
+
+        mContext.startActivity(intent);
+    }
+
+    public void askResources(List<Device> devicelist) {
+        this.configuredDeviceList = devicelist;
+        IRemoteService remoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+        try
+        {
+            remoteService.sendResourceRequests(devicelist);
+        }
+        catch (RemoteException e)
+        {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+
+        for (Device d : configuredDeviceList) {
+            if(!nameToDevice.containsKey(d.deviceName)){
+                nameToDevice.put(d.deviceName, d);
+            }
+        }
+
+    }
+
+    public void allowResources(String deviceName, int allowedResources[]) //Device device)
+    {
+        Log.d(TAG, "1 - " + "deviceName / " + Arrays.toString(allowedResources));
+        if(allowedResources != null)
+        {
+            Log.d(TAG, "2 - " + "deviceName / " + Arrays.toString(allowedResources));
+            if(nameToDevice.containsKey(deviceName))
+            {
+                Log.d(TAG, "3 - " + "deviceName / " + Arrays.toString(allowedResources));
+
+                Device device = nameToDevice.get(deviceName);
+
+                //collaboroid
+                //cachedActivityResourceDevices.add(device);
+
+                Log.d(TAG, "4 - " + "deviceName / " + Arrays.toString(allowedResources));
+                for(int i : allowedResources)
+                {
+                    device.allowedResources[i] = 1;
+                    if(!resourceToAllowedDevices.get(i).contains(device.ipaddress))
+                        resourceToAllowedDevices.get(i).add(device.ipaddress);
+                }
+
+                Log.d(TAG, "5 - " + "deviceName / " + Arrays.toString(allowedResources));
+
+                IRemoteService remoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+                try
+                {
+                    remoteService.respondAllowedResources(device.ipaddress, allowedResources);
+                }
+                catch (RemoteException e)
+                {
+                    // TODO Auto-generated catch block
+                    e.printStackTrace();
+                }
+            }
+
+        }
+    	/*else if(allowedResources == null)
+    	{
+
+    	}
+
+    	if(nameToDevice.containsKey(deviceName))
+    	{
+
+    	}
+    	Device device = nameToDevice.get(deviceName);
+
+
+
+
+
+    	if(!nameToDevice.containsKey(device.deviceName))
+    		nameToDevice.put(device.deviceName, device);
+
+        for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+        {
+        	if(device.allowedResources[i] == 1 && !resourceToAllowedDevices.get(i).contains(device.ipaddress))
+        		resourceToAllowedDevices.get(i).add(device.ipaddress);
+        }*/
+    }
+
+    public void categorizeDevices() {
+        for (Device d : configuredDeviceList) {
+            if (!nameToDevice.containsKey(d.deviceName))
+                nameToDevice.put(d.deviceName, d);
+
+            for (int i = 0; i < Device.RESOURCE_TYPE_SIZE; i++) {
+                if (d.allowedResources[i] == 1 && !resourceToAllowedDevices.get(i).contains(d.ipaddress))
+                    resourceToAllowedDevices.get(i).add(d.ipaddress);
+            }
+        }
+    }
+
+    @Override
+    public boolean isAllowedForResource(String device, int resource) throws RemoteException {
+        // TODO Auto-generated method stub
+        return resourceToAllowedDevices.get(resource).contains(device);
+    }
+
+    public String recommendDevice(List<Device> devicelist) throws RemoteException {
+        // TODO Auto-generated method stub
+
+        if (!devicelist.isEmpty()) {
+
+            Collections.sort(devicelist, new RecommenderPeerCompare());
+            Device p = devicelist.get(0);
+            for (int i = 0; i < devicelist.size(); i++) {
+                Device d = devicelist.get(i);
+                Log.i("RecommService", "address: " + d.ipaddress + "  SystemServer: "
+                        + d.isSystemServiceOn
+                        + "  TaskServer: " + d.isTaskExecutorOn);
+            }
+            return p.ipaddress;
+        }
+        return null;
+    }
+
+    public List<Device> getDeviceList(int kind) throws RemoteException {
+        // TODO Auto-generated method stub
+        findDevice();
+        /*
+         * Set<String> keys = DeviceList.getDevices().keySet(); List<Device> ps
+         * = new ArrayList<Device>(); for (String key : keys) {
+         * ps.add(DeviceList.getDevices().get(key)); }
+         */
+        return getServerList(kind);
+    }
+
+    public String[] getSystemServiceOnServerList() throws RemoteException {
+        return (String[]) getServerList(SYSTEM_SERVICE_LIST).toArray();
+    }
+
+    public String[] getTaskExecutorOnServerList() throws RemoteException {
+        return (String[]) getServerList(TASK_EXECUTOR_LIST).toArray();
+    }
+
+    public ArrayList<Device> getServerList(int kind) throws RemoteException {
+        ArrayList<Device> deviceList = new ArrayList<Device>();
+        Collection<Device> cp = DeviceList.getDevices().values();
+        for (Device p : cp) {
+            if (kind == SYSTEM_SERVICE_LIST) {
+                if (p.isSystemServiceOn > 0) {
+                    deviceList.add(p);
+                }
+            } else if (kind == TASK_EXECUTOR_LIST) {
+                if (p.isTaskExecutorOn > 0) {
+                    deviceList.add(p);
+                }
+            }
+        }
+        return deviceList;
+    }
+
+    /*
+     * public ArrayList<String> getServerList(int KIND) throws RemoteException{
+     * ArrayList<String> serverlist = new ArrayList<String>();
+     * Collection<Device> cp = DeviceList.getDevices().values(); for(Device p :
+     * cp){ if(KIND == SYSTEM_SERVICE_LIST){ if(p.isSystemServiceOn > 0){
+     * serverlist.add(p.ipaddress); } } else if(KIND == TASK_EXECUTOR_LIST){
+     * if(p.isTaskExecutorOn > 0){ serverlist.add(p.ipaddress); } } } return
+     * serverlist; }
+     */
+
+    private void findDevice() {
+        // TODO Auto-generated method stub
+        InetAddress broadcast = getBroadcastIp();
+        Log.i("RecommService", "broadcast: " + broadcast.toString());
+        sender = new RecommenderUDPSender(broadcast);
+        sender.start();
+    }
+
+    public InetAddress getBroadcastIp() {
+        try {
+            WifiManager mWifi = (WifiManager) mContext
+                    .getSystemService(Context.WIFI_SERVICE);
+            WifiInfo info = mWifi.getConnectionInfo();
+
+            DhcpInfo dhcp = mWifi.getDhcpInfo();
+
+            int broadcast = (dhcp.ipAddress & dhcp.netmask) | ~dhcp.netmask;
+
+            byte[] quads = new byte[4];
+            for (int k = 0; k < 4; k++)
+                quads[k] = (byte) ((broadcast >> k * 8) & 0xFF);
+
+            // Log.d("UDP", "main ipadd1 = : " + dhcp.ipAddress);
+            // Log.d("UDP", "main ipadd2 = : " + dhcp.netmask);
+            Log.d("UDP", "broadcast ip = : " + InetAddress.getByAddress(quads));
+            return InetAddress.getByAddress(quads);
+        } catch (Exception e) {
+
+        }
+        return null;
+    }
+
+    //collaboroid
+    //String getHaveDexFiles();
+    //void addHaveDexFiles(String dexFiles);
+    public String getHaveDexFiles(int deviceNum){
+        Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManagementService]");
+        //Device d = cachedActivityResourceDevices.get(deviceNum);
+        //Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManagementService] HaveDexFiles : " + d.HaveDexFiles);
+        return "";
+    }
+
+    public void addHaveDexFiles(int deviceNum, String dexFiles){
+        Log.d("SBJSBJ", "SBJSBJ addHaveDexFiles [DeviceManagementService]");
+        //Log.d("SBJSBJ", "SBJSBJ addHaveDexFiles [DeviceManagementService] size : " + cachedActivityDevices.size());
+        //cachedActivityResourceDevices.get(deviceNum).HaveDexFiles += "@" + dexFiles;
+    }
+
+    //samd
+    //initialize
+
+
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/devicemanagement/ReturnThread.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/devicemanagement/ReturnThread.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/devicemanagement/ReturnThread.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/devicemanagement/ReturnThread.java	2017-01-29 02:51:16.473854000 +0900
@@ -0,0 +1,57 @@
+
+package com.android.server.devicemanagement;
+
+import android.service.devicemanagement.Device;
+import android.service.devicemanagement.DeviceList;
+import android.util.Log;
+
+import java.io.DataInputStream;
+import java.io.IOException;
+import java.io.InputStream;
+import java.net.InetAddress;
+import java.net.Socket;
+
+public class ReturnThread extends Thread {
+    public static final int PORT = 9050;
+
+    private Socket socket;
+
+    public ReturnThread(Socket socket) {
+        this.socket = socket;
+    }
+
+    public void run() {
+        try {
+            InputStream in = socket.getInputStream();
+            DataInputStream dis = new DataInputStream(in);
+            String return_msg = dis.readUTF();
+
+            String[] temp2 = return_msg.split("_");
+            String macAddr = temp2[0];
+            String ipaddress = temp2[1];
+            String idlecpu = temp2[2];
+            String deviceName = temp2[3];
+            int isCollaboroidOn = Integer.parseInt(temp2[4]);
+            int isTaskExecutor = Integer.parseInt(temp2[5]);
+
+            Log.i("ReturnThread", "device: " + macAddr + "  return ip: " + ipaddress
+                    + "  return cpu usage: " + idlecpu);
+            
+            Device p = new Device(ipaddress, idlecpu, deviceName, isCollaboroidOn, isTaskExecutor);
+            Log.i("ReturnThread", "device name: " + macAddr + " / peer: " + p.toString());
+            
+            if (ipaddress.equals(RecommenderUDPReceiver.getIpaddress())){
+                Log.i("ReturnThread", "Return from own device: " + ipaddress + ", " + InetAddress.getLocalHost().getHostAddress());
+            }
+            else{
+                DeviceList.getDevices().put(macAddr, p);
+                Log.i("ReturnThread", "Added to Peer list " + ipaddress + ", " + RecommenderUDPReceiver.getIpaddress());
+            }
+            
+            socket.close();
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+    }
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/DistributedComputingService.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/DistributedComputingService.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/DistributedComputingService.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/DistributedComputingService.java	2017-01-29 02:51:16.789858000 +0900
@@ -0,0 +1,93 @@
+package com.android.server.distribute;
+
+import java.util.ArrayList;
+
+import android.content.Context;
+import android.service.distribute.IDistributedComputingService;
+import android.util.Log;
+
+public class DistributedComputingService extends IDistributedComputingService.Stub
+{
+	private static final String TAG = "DistributedComputing";
+	// private static final int SERVERPORT = 55555;
+
+	Context mContext;
+
+	private JobManager mJobManager;
+	
+	// For Server
+	private TaskExecutor mTaskExecutor = null;
+	private Thread taskExecutorThread = null;
+
+	public DistributedComputingService(Context context)
+	{
+		mContext = context;
+	}
+
+
+	@Override
+	public void startJobManager(String ip)
+	{
+		if(mJobManager == null)
+		{
+			ArrayList<String> ip_list = new ArrayList<String>();
+			ip_list.add(ip);
+			mJobManager = new JobManager(ip_list);
+		}
+		else
+			Log.d(TAG, "HAHA?");
+	}
+	
+	@Override
+	public void stopJobManager()
+	{
+		
+	}
+	
+	@Override
+	public void startTaskExecutor()
+	{
+		if(taskExecutorThread == null)
+		{
+			mTaskExecutor = new TaskExecutor();
+			taskExecutorThread = new Thread(mTaskExecutor);
+			
+			taskExecutorThread.start();
+		}
+	}
+	
+	@Override
+	public void stopTaskExecutor()
+	{
+		if(taskExecutorThread != null)
+		{
+			mTaskExecutor.terminate();
+			taskExecutorThread.interrupt();
+		}
+	}
+
+	@Override
+	public int sum(int start, int end)
+	{
+		// TODO Auto-generated method stub
+		ArrayList<Object> paras = new ArrayList<Object>();
+		paras.add(start);
+		paras.add(end);
+		
+		//mJobManager.submitTask(new TaskRequest("com.android.server.distribute.Sum", paras));
+		mJobManager.submitTask(new TaskRequest("SUM", paras));
+		
+		Log.d(TAG, "result: " + mJobManager.executeJob()[0]);
+		
+		return 432;
+	}
+
+
+
+	@Override
+	public void testOperation()
+	{
+		// TODO Auto-generated method stub
+		sum(10, 50);
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/JobManager.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/JobManager.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/JobManager.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/JobManager.java	2017-01-29 02:51:16.793858000 +0900
@@ -0,0 +1,291 @@
+package com.android.server.distribute;
+
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.Socket;
+import java.util.ArrayList;
+import java.util.concurrent.atomic.AtomicInteger;
+
+import android.util.Log;
+
+public class JobManager 
+{
+	private static final String TAG = "JobManager";
+	private static final int DISTRIBUTED_COMPUTING_PORT = 55556;
+	
+	int node_num = 0, task_num = 0, total_task_num = 0;
+	
+	ArrayList<String> nodes;
+	//private final IRecommender mService;
+	
+	// for node performance
+	long node_info[][];
+	int node_perf_ratio[];
+	
+	long total_runtime = 0;
+	boolean isrunning = false;
+
+	int task_length, taskinfo_length;
+
+	AtomicInteger current_task = new AtomicInteger(0);
+	
+	ArrayList<TaskRequest> tasks;
+	
+	public JobManager(ArrayList<String> ip_list)
+	{
+		//mService = IRecommender.Stub.asInterface(ServiceManager.getService("recommender"));
+		
+		//nodes = mService.getPeerList();
+		nodes = ip_list;
+		node_num = nodes.size();
+		
+		node_info = new long[node_num][2]; // [][0]=task_count, [][1]=runtime
+		node_perf_ratio = new int[node_num];
+		
+		tasks = new ArrayList<TaskRequest>();
+		
+		Log.d(TAG, nodes.toString());
+		Log.d(TAG, "node_num: " + node_num);
+	}
+	
+	public void submitTask(TaskRequest task)
+	{
+		tasks.add(task);
+		task_num++;
+		Log.d(TAG, tasks.toString());
+	}
+	
+	/*public <T> Task submitTask(T t)
+	{
+		Task task = (Task)t;
+		
+		return task;
+	}*/
+	
+	public Object[] executeJob()
+	{
+		Thread node_thread[] = new Thread[node_num];
+		final long[][] job_info = new long[node_num][2];
+		
+		long begin, terminate;
+		
+		final Object[] results = new Object[task_num];
+		
+		// calculate node performance
+		if(node_perf_ratio[0] == 0)
+			executeTestcode();
+		else
+			for(int i=1; i<node_num; i++)
+				node_perf_ratio[i] = (int) Math.round((double)((float)node_info[i][1]/(float)node_info[i][0]) / ((float)node_info[0][1]/(float)node_info[0][0]));
+		
+		begin = System.currentTimeMillis();
+		try
+		{
+			// create thread for each node
+			for(int i = 0; i < node_num; i++)
+			{
+				final int num = i;
+				node_thread[i] = new Thread(new Runnable()
+				{
+					public void run()
+					{
+						long start=0, end=0;
+						job_info[num][0] = 0;
+						job_info[num][1] = 0;
+						
+						if(nodes.get(num).equals("localhost"))
+						{
+							int running_task = 0;// current_task.getAndIncrement();
+							
+							while((running_task=current_task.getAndIncrement()) < task_num)
+							{
+								if((task_num-running_task) < node_perf_ratio[num])
+								{
+									Log.d(TAG, "remain task: " + (task_num-running_task));
+									task_num++;
+									tasks.add(tasks.get(running_task));				
+									break;
+								}
+							
+								start = System.currentTimeMillis();
+	
+								//tasks.get(running_task).setValue(tasks.get(running_task).getTask().execute());
+						
+								end = System.currentTimeMillis();		
+								
+								job_info[num][0]++;
+								job_info[num][1]+=(end-start);
+							}
+						}
+						else
+						{
+							try
+							{
+								Socket node = new Socket(nodes.get(num), DISTRIBUTED_COMPUTING_PORT);
+
+								ObjectOutputStream oos = new ObjectOutputStream(node.getOutputStream());
+								ObjectInputStream ois = new ObjectInputStream(node.getInputStream());
+
+								int running_task=0;
+								
+								while((running_task=current_task.getAndIncrement()) < task_num)
+								{
+									Log.d(TAG, "running_task: " + running_task);
+									Log.d(TAG, "task_num: " + task_num);
+									
+									if((task_num-running_task) < node_perf_ratio[num])
+									{
+										Log.d(TAG, "remain task: " + (task_num-running_task));
+										task_num++;
+										tasks.add(tasks.get(running_task));				
+										break;
+									}
+									
+									start = System.currentTimeMillis();
+	
+									oos.writeObject(tasks.get(running_task));
+									//oos.flush();
+
+									//tasks.get(running_task).setValue(ois.readObject());
+									//reois.readObject()
+									
+									//results.set(running_task, ois.readObject());
+									results[running_task] = ois.readObject();
+									
+									end = System.currentTimeMillis();
+									
+									job_info[num][0]++;
+									job_info[num][1]+=(end-start);
+								}
+								oos.writeObject(new TaskRequest("BYE", null));
+								node.close();
+							}
+							catch (Exception e)
+							{
+								// TODO Auto-generated catch block
+								Log.e(TAG, "ExecuteJob exception:");
+								e.printStackTrace();
+							}
+						}
+					}
+				});
+				node_thread[i].start();
+			}
+			for(int i = 0; i < node_num; i++)
+				node_thread[i].join();
+		}
+		catch (Exception e)
+		{
+			e.printStackTrace();
+		}
+		
+		terminate = System.currentTimeMillis();
+		tasks.clear();
+		current_task.set(0);
+		collect_info(job_info);
+		total_runtime += (terminate - begin);
+		isrunning = false;
+		total_task_num += task_num;
+		task_num = 0;
+		
+		return results;
+	}
+	
+	public void executeTestcode()
+	{
+		final ArrayList<String> temp_list = new ArrayList<String>();
+		final ArrayList<Long> testcode_runtime = new ArrayList<Long>();
+		
+		final ArrayList<Object> paras = new ArrayList<Object>();
+		paras.add(10);
+		paras.add(100000);
+		
+		Thread node_thread[] = new Thread[node_num];
+		
+		try
+		{
+			// create thread for each node
+			for(int i=0; i<node_num; i++)
+			{
+				final int num = i;
+				node_thread[i] = new Thread(new Runnable()
+				{
+					public void run()
+					{
+						try
+						{
+							long start, end;
+							Socket node = new Socket(nodes.get(num), DISTRIBUTED_COMPUTING_PORT);
+
+							ObjectOutputStream oos = new ObjectOutputStream(node.getOutputStream());
+							ObjectInputStream ois = new ObjectInputStream(node.getInputStream());
+
+							start = System.currentTimeMillis();
+
+							oos.writeObject(new TaskRequest("SUM", paras));
+							ois.readObject();
+							
+							end = System.currentTimeMillis();
+
+							temp_list.add(nodes.get(num));
+							testcode_runtime.add(end-start);
+							
+							oos.writeObject(new TaskRequest("BYE", null));
+							node.close();
+						}
+						catch (Exception e)
+						{
+							// TODO Auto-generated catch block
+							Log.e(TAG, "TestCode exception:");
+							e.printStackTrace();
+						}											
+					}
+				});
+				node_thread[i].start();
+			}		
+			for(int i=0; i<node_num; i++)
+				node_thread[i].join();		
+			Log.d(TAG, "all finish!" + node_num);
+		}
+		catch(Exception e)
+		{
+			e.printStackTrace();
+		}
+		
+		nodes = temp_list;
+		
+		for(int i=0; i<node_num; i++)
+    		node_perf_ratio[i] = (int) Math.round((double)testcode_runtime.get(i) / testcode_runtime.get(0));
+	}
+	
+	public void collect_info(long[][] job_info)
+	{
+		for(int i = 0; i < node_num; i++)
+		{
+			node_info[i][0] += job_info[i][0];
+			node_info[i][1] += job_info[i][1];
+		}
+	}
+
+	public void print_info()
+	{
+		System.out
+				.println(" task count | % of all tasks | task time sum | time per task | job server");
+
+		for(int i = 0; i < node_num; i++)
+			System.out.printf(
+					"%11d |        %7.2f |     %9.3f |  %12.6f | %s\n",
+					node_info[i][0],
+					(((float) node_info[i][0] / (float) total_task_num)) * 100,
+					(float) node_info[i][1] / 1000,
+					((float) node_info[i][1] / (float) node_info[i][0]) / 1000,
+					nodes.get(i));
+
+		System.out.println("\ntotal runtime is " + total_runtime / 1000 + "."
+				+ total_runtime % 1000 + "sec");
+
+		System.out.println("task_length : " + task_length + "\ntaskinfo_length : "
+				+ taskinfo_length);
+
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/NodeManager.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/NodeManager.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/NodeManager.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/NodeManager.java	2017-01-29 02:51:16.793858000 +0900
@@ -0,0 +1,24 @@
+package com.android.server.distribute;
+
+import android.os.ServiceManager;
+import android.service.devicemanagement.IDeviceManagementService;
+
+
+public class NodeManager 
+{
+	private final IDeviceManagementService mService;
+	
+	public NodeManager()
+	{
+		mService = IDeviceManagementService.Stub.asInterface(ServiceManager.getService("devicemanager"));
+	}
+	
+	/*public ArrayList<String> getNodes()
+	{
+		List<Peer> peers = mService.getPeerList();
+		
+		ArrayList<String> nodes = new ArrayList<String>();
+		
+		nodes.addAll(peers.)
+	}*/
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/Sum.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/Sum.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/distribute/Sum.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/distribute/Sum.java	2017-01-29 02:51:16.789858000 +0900
@@ -0,0 +1,28 @@
+package com.android.server.distribute;
+
+public class Sum implements Task<Integer>
+{
+	private final int min, max;
+	
+	public Sum(int min, int max)
+	{
+		this.min = min;
+		this.max = max;
+	}
+
+	public Integer execute()
+	{
+		return sum(min, max);
+	}
+	
+	public static int sum(int min, int max)
+	{
+		int i=0;
+		int result = 0;
+		
+		for(i=min; i<max; i++)
+			result += i;
+		
+		return result;
+	}
+}
